#include "ComposantServeurTempsQuiPasse.h"
#include "PointDeConnexion.h"


HRESULT ComposantServeurTempsQuiPasse::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      *ppv = static_cast<IUnknown *>(static_cast<IUnknownImpl *>(this));
   }
   else if (riid == IID_IConfigTemps)
   {
      *ppv = static_cast<IConfigTemps *>(this);
   }
   else if (riid == IID_IConnectionPointContainer)
   {
      *ppv = static_cast<IConnectionPointContainer *>(this);
   }
   else
   {
      // traitement d'erreur
      *ppv = 0; // NULL
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}


// constructeur
ComposantServeurTempsQuiPasse::ComposantServeurTempsQuiPasse () :
   IConfigTempsImpl (), IUnknownImpl (), IConnectionPointContainerImpl (), Minuterie ()
{
   Ajouter (new PointDeConnexion (this, IID_ITempsQuiPasse));
   Lancer ();
}

// destructeur
ComposantServeurTempsQuiPasse::~ComposantServeurTempsQuiPasse ()
{
}

void ComposantServeurTempsQuiPasse::Tic ()
{
   ProchainTic ();
   if (ChangementEtat ())
   {
      IConnectionPoint *pCP;
      if (SUCCEEDED (FindConnectionPoint (IID_ITempsQuiPasse, &pCP)))
      {
         IEnumConnections *piec;
         // on a un point de connection sur ITempsQuiPasse
         if (SUCCEEDED (pCP->EnumConnections (&piec)))
         {
	         CONNECTDATA my_cd;
	         ULONG dd;
            // faire simple: rappeler le premier client seulement
            HRESULT hr = piec->Next(1, &my_cd, &dd);
            while (dd)
            {
               ITempsQuiPasse *itqp;
               if (SUCCEEDED (my_cd.pUnk->QueryInterface (IID_ITempsQuiPasse,
                                                          reinterpret_cast<void **> (&itqp))))
               {
                  HRESULT hr = itqp->Tick (GetNbUnites (), GetNbSaisons ());
                  itqp->Release ();
               }
               hr = piec->Next(1, &my_cd, &dd);
            }
            piec->Release ();
         }
         pCP->Release ();
      }
      // Le changement a t not
      ResetEtat ();
   }
}
