#include "FabriqueServeurTempsQuiPasse.h"
#include "ComposantServeurTempsQuiPasse.h"

// ----------------------------------------------------
// Implmentation des mthodes de la classe FabriqueServeurTempsQuiPasse
// (pour IUnknown)
// ----------------------------------------------------

ComposantServeurTempsQuiPasse *FabriqueServeurTempsQuiPasse::m_ServeurCree = 0;

HRESULT FabriqueServeurTempsQuiPasse::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      *ppv = static_cast<IUnknown*> (static_cast<IClassFactory *> (this));
   }
   else if (riid == IID_IClassFactory)
   {
      *ppv = static_cast<IClassFactory*> (this);
   }
   else
   {
      // traitement d'erreur
      *ppv = 0; // NULL
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}

// ----------------------------------------------------
// Implmentation des mthodes de la classe FabriqueServeurTempsQuiPasse
// (pour IClassFactory)
// ----------------------------------------------------

HRESULT FabriqueServeurTempsQuiPasse::CreateInstance (IUnknown *pUnkOuter,
                                                REFIID riid,
                                                void **ppv)
{
   if (!m_ServeurCree)
   {
      if (pUnkOuter != 0)
      {
         return CLASS_E_NOAGGREGATION;
      }
      m_ServeurCree = new ComposantServeurTempsQuiPasse();
      if (!m_ServeurCree)
         return E_OUTOFMEMORY;
   }
   else
   {
      m_ServeurCree->AddRef ();
   }
   HRESULT hr = m_ServeurCree->QueryInterface (riid, ppv);
   m_ServeurCree->Release ();
   return hr;
}
