#include "IConnectionPointContainerImpl.h"
#include "PointDeConnexion.h"
#include "EnumerateurDeConnexions.h"
#include <ctime>

bool IConnectionPointContainerImpl::Ajouter (PointDeConnexion *pc)
{
   m_PointsDeConnexion.push_back (pc);
   return true;
}


IConnectionPointContainerImpl::IConnectionPointContainerImpl() :
   IConnectionPointContainer ()
{
}

IConnectionPointContainerImpl::~IConnectionPointContainerImpl()
{
   std::vector<PointDeConnexion *>::iterator itt;
   for (itt = m_PointsDeConnexion.begin (); itt != m_PointsDeConnexion.end (); itt++)
   {
      (*itt)->Release ();
   }
}

// Pour IConnectionPointContainer
HRESULT STDMETHODCALLTYPE IConnectionPointContainerImpl::EnumConnectionPoints
   (IEnumConnectionPoints **ppEnum)
{
   // Je ne m'en sers pas, parce qye j'utilise un seul point de connexion
   // dans mon serveur. Cela dit, on pourrait implanter cette mthode en
   // prenant comme modle IConnectionPointImpl::EnumConnections()...
   return E_NOTIMPL;
}

HRESULT STDMETHODCALLTYPE IConnectionPointContainerImpl::FindConnectionPoint
   (REFIID riid, IConnectionPoint **ppCP)
{
   std::vector<PointDeConnexion *>::iterator itt;
   for (itt = m_PointsDeConnexion.begin (); itt != m_PointsDeConnexion.end (); itt++)
   {
      if ((*itt)->GetInterfaceIID () == riid)
      {
         return (*itt)->QueryInterface(IID_IConnectionPoint,
                                       reinterpret_cast<void**>(ppCP));
      }
   }
	return E_NOINTERFACE;
}


