#ifndef ICONNECTIONPOINTIMPL_H
#define ICONNECTIONPOINTIMPL_H

#include "../Commun/IConfigTemps.h"
#include <vector>
#include <olectl.h> // pour les points de connexion
#include "EnumerateurDeConnexions.h"

class IConnectionPointImpl : virtual public IConnectionPoint
{
   EnumerateurDeConnexions m_Connexions;

   // Pour gestion interne
   unsigned long GenererCookieUnique () const;
   bool CookieExiste (const unsigned long) const;
public:
   // Pour IConnectionPoint
   HRESULT STDMETHODCALLTYPE GetConnectionInterface(IID *pIID);
   HRESULT STDMETHODCALLTYPE GetConnectionPointContainer(IConnectionPointContainer **ppCPC);
   HRESULT STDMETHODCALLTYPE Advise(IUnknown *pUnkSink,
                                    DWORD *pdwCookie);
   HRESULT STDMETHODCALLTYPE Unadvise(DWORD dwCookie);
   HRESULT STDMETHODCALLTYPE EnumConnections( IEnumConnections **ppEnum);

   // Pour support interne ( surcharger par l'enfant)
   virtual IConnectionPointContainer *GetParent () = 0;
   virtual REFIID GetInterfaceIID () const = 0;
   // Pour gestion normale
   IConnectionPointImpl ();
   virtual ~IConnectionPointImpl ();
};

#endif // !defined ICONNECTIONPOINTIMPL_H
