#ifndef POINTDECONNEXION_H
#define POINTDECONNEXION_H

#include <olectl.h> // IConnectionPointContainer
#include "IConnectionPointImpl.h"

class PointDeConnexion : public virtual IConnectionPointImpl,
                         public virtual IUnknownImpl
{
   REFIID m_riid;
   IConnectionPointContainer *m_Parent;
public:
   PointDeConnexion (IConnectionPointContainer *Parent, REFIID riid) :
      IConnectionPointImpl (),
      IUnknownImpl (),
      m_riid (riid)
   {
      m_Parent = Parent;
   }
   virtual ~PointDeConnexion ()
   {
   }
   unsigned long __stdcall AddRef () { return IUnknownImpl::AddRef (); }
   unsigned long __stdcall Release () { return IUnknownImpl::Release (); }
   HRESULT __stdcall QueryInterface (REFIID riid, void ** ppv);

   // Support pour IConnectionPointImpl
   virtual IConnectionPointContainer *GetParent ()
   {
      return m_Parent;
   }
   virtual REFIID GetInterfaceIID () const
   {
      return m_riid;
   }
};

#endif // !defined POINTDECONNEXION_H